#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor{
	int vrednost;
	struct _cvor *sledeci;
}cvor;

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int vrednost){
	cvor *a;
	a = malloc(sizeof(cvor));
	if(a == NULL)
		greska();
	a->vrednost = vrednost;
	a->sledeci = NULL;
	//vracamo adresu
	return a;
}

//prvi nacin - da vratimo novu glavu liste
cvor* dodaj_na_pocetak(cvor *glava, int v){
	cvor *novi = kreiraj_cvor(v);
	novi->sledeci = glava;
	return novi;
}

//ne savetujem - drugi nacin da izmenimo glavu liste
void dodaj_na_pocetak2(cvor **glava, int v){
	cvor *novi = kreiraj_cvor(v);
	novi->sledeci = *glava;
	*glava = novi;
}

cvor* dodaj_na_kraj_iter(cvor *g, int v){
	if(g == NULL)
		return kreiraj_cvor(v);
	
	cvor *tmp = g;
	while(tmp->sledeci != NULL)
		tmp = tmp->sledeci;
	
	tmp->sledeci = kreiraj_cvor(v);
	
	return g;
}

cvor* dodaj_na_kraj(cvor *g, int v){
	if(g == NULL)
		return kreiraj_cvor(v);
	
	g->sledeci = dodaj_na_kraj(g->sledeci, v);
	return g;
}

void ispis(cvor *glava){
	if(glava == NULL)
		return;
	
	printf("%d ", glava->vrednost);
	ispis(glava->sledeci);
}

cvor *oslobodi(cvor *g){
	if(g == NULL)
		return NULL;

	oslobodi(g->sledeci);
	free(g);
	return NULL;
}

cvor *ucitaj_listu(){
	int x;
	cvor *g = NULL;
	while(1){
		scanf("%d", &x);
		if(x == 0)
			break;
		
		g = dodaj_na_kraj(g, x);
	}
	return g;
}

//brisemo svako pojavljivanje broja x u listi
//i vracamo novu glavu
cvor* obrisi(cvor *g, int x){
	//iterativna verzija obavezno za domaci!!!
	if(g == NULL)
		return NULL;
	
	cvor *novi_ostatak_liste = obrisi(g->sledeci, x);
	//2 slucaja: u glavi se nalazi ili ne nalazi x
	if(g->vrednost == x){
		free(g);
		return novi_ostatak_liste;
	}
	else{
		g->sledeci = novi_ostatak_liste;
		return g;
	}
}

cvor *ubaci_u_sortiranu_listu(cvor *g, int v){
	if(g == NULL)
		return kreiraj_cvor(v);
	
	if(v < g->vrednost)
		return dodaj_na_pocetak(g, v);
	
	g->sledeci = ubaci_u_sortiranu_listu(g->sledeci, v);
	return g;
}

cvor *spoj_sortirano(cvor *g1, cvor *g2){
	if(g1 == NULL)
		return g2;
	if(g2 == NULL)
		return g1;
	
	if(g1->vrednost < g2->vrednost){
		g1->sledeci = spoj_sortirano(g1->sledeci, g2);
		return g1;
	}
	else{
		g2->sledeci = spoj_sortirano(g1, g2->sledeci);
		return g2;
	}
}

cvor *ucitaj_sortiranu_listu(){
	int x;
	cvor *g = NULL;
	while(1){
		scanf("%d", &x);
		if(x == 0)
			break;
		
		g = ubaci_u_sortiranu_listu(g, x);
	}
	return g;
}

int main(){
	
	cvor *a = ucitaj_sortiranu_listu();
	cvor *b = ucitaj_sortiranu_listu();
	
	ispis(a);
	printf("\n");
	
	ispis(b);
	printf("\n");
	
	cvor *c = spoj_sortirano(a, b);
	ispis(c);
	printf("\n");
	
	c = oslobodi(c);
	/******************
	cvor *g = ucitaj_listu();
	ispis(g);
	g = obrisi(g, 2);
	printf("\n");
	ispis(g);
	g = oslobodi(g);
	********************/
	
	/***************************
	OVO JE NAS PRVI TEST
	//UVEK SE PRAZNA LISTA INICIJALIZUJE NA NULL!!!
	cvor *glava = NULL;
	
	//za test nam trebaju 4 liste
	cvor *gp1 = NULL; //na pocetek prva implementacija
	cvor *gp2 = NULL; //na pocetak druga implementacija
	cvor *gkrek = NULL; //na kraj rek.
	cvor *gkiter = NULL; //na kraj iter.
	
	//dodajemo u listu sve dok korisnik ne unese 0
	int x;
	while(1){
		scanf("%d", &x);
		if(x == 0)
			break;
		
		gp1 = dodaj_na_pocetak(gp1, x);
		dodaj_na_pocetak2(&gp2, x);
		gkiter = dodaj_na_kraj_iter(gkiter, x);
		gkrek = dodaj_na_kraj(gkrek, x);
	}
	
	ispis(gp1);
	printf("\n");
	
	ispis(gp2);
	printf("\n");
	
	ispis(gkiter);
	printf("\n");
	
	ispis(gkrek);
	printf("\n");
	
	gp1 = oslobodi(gp1);
	gp2 = oslobodi(gp2);
	gkiter = oslobodi(gkiter);
	gkrek = oslobodi(gkrek);
	********************************/
}